#!/bin/sh

# This file is part of netfilter-persistent
# (was iptables-persistent)
# Copyright (C) 2009, Simon Richter <sjr@debian.org>
# Copyright (C) 2010, 2014 Jonathan Wiltshire <jmw@debian.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, either version 3
# of the License, or (at your option) any later version.

set -e

PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

# Exit fast if IPv6 is disabled
test -e /proc/sys/net/ipv6 || exit 0

load_rules()
{
    #load IPv6 rules
    if [ ! -f /etc/iptables/rules.v6 ]; then
        echo "Warning: skipping IPv6 (no rules to load)"
    else
        ip6tables-restore < /etc/iptables/rules.v6
    fi
}

save_rules()
{
    if [ ! "${IPTABLES_SKIP_SAVE}x" = "yesx" ]; then
        #save IPv6 rules
        #need at least ip6table_filter loaded:
        modprobe -b -q ip6table_filter || true
        if [ ! -f /proc/net/ip6_tables_names ]; then
            log_action_cont_msg "Warning: skipping IPv6 (Kernel support is missing)"
        else
            touch /etc/iptables/rules.v6
            ip6tables-save > /etc/iptables/rules.v6
            chmod 0640 /etc/iptables/rules.v6
        fi
    fi
}

flush_rules()
{
    if [ ! -f /proc/net/ip6_tables_names ]; then
        echo "Warning: skipping IPv6 (Kernel support is missing)"
    elif [ $(which ip6tables) ]; then
        for chain in INPUT FORWARD OUTPUT
            do
            ip6tables -P $chain ACCEPT
        done
        for param in F Z X; do ip6tables -$param; done
        for table in $(cat /proc/net/ip6_tables_names)
            do
            ip6tables -t $table -F
            ip6tables -t $table -Z
            ip6tables -t $table -X
        done
    fi
}

case "$1" in
start|restart|reload|force-reload)
    load_rules
    ;;
save)
    save_rules
    ;;
stop)
    # Why? because if stop is used, the firewall gets flushed for a variable
    # amount of time during package upgrades, leaving the machine vulnerable
    # It's also not always desirable to flush during purge
    echo "Automatic flushing disabled, use \"flush\" instead of \"stop\""
    ;;
flush)
    flush_rules
    ;;
*)
    echo "Usage: $0 {start|restart|reload|force-reload|save|flush}" >&2
    exit 1
    ;;
esac
